//#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start
using System;
using System.Collections;
using System.Text;

using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;
using System.Data;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 해피쿠폰 발송
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    class CpnSend : PaymentBase, IPaymentUs
    {
        /// <summary>
        /// 현재 등록중인 기타 정보
        /// </summary>
        protected Column.TR_ETC.DATA m_cEtcItem = null;

        public CpnSend()
        {
        }

        #region SearchPayment 결제 조회
        /// <summary>
        /// 결제 조회
        /// </summary>
        /// <param name="aParam"></param>
        /// <param name="aRet"></param>
        /// <returns></returns>
        public string SearchPayment(string[] aParam, ref string[] aRet)
        {
            return UserCom.RST_ERR;
        }
        #endregion

        #region GetPayment 결제 정보 획득
        /// <summary>
        /// 결제 정보 획득
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public object GetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;

            try
            {

            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region SetPayment 결제 등록
        /// <summary>
        /// 결제 등록(해피포인트 사후 적립)
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInEncData = "", sReqDivCd = "", sAppCardNo = "", sOPPRID = "";

            try
            {
                sInPutType = aParam[0];                     // 입력구분
                sInPutData = aParam[1];                     // 입력데이터(마스킹)
                sInEncData = aParam[2];                     // 카드데이터(암호화)
                sReqDivCd = aParam[3];                      // 요청구분코드
                sAppCardNo = aParam[4];                     // 입력데이터
                sOPPRID = aParam[5];                        // 오퍼id

                m_cEtcItem = new Column.TR_ETC.DATA();      // 결과 저장 변수 생성
                m_cEtcItem.ETC_WAY_CD = ItemConst.TR_ITEM_ID.ETC_INFO_ITEM;
                m_cEtcItem.ETC_DTL_CD_01 = ItemConst.TR_ITEM_ID.ETC_INFO.HAPPYCPN_SEND;

                sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.NORMAL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A, "HPY", sInPutType, sInPutData, sInEncData, sReqDivCd, sOPPRID);
                if (sRet != UserCom.RST_OK) return sRet;

                m_cEtcItem.ETC_DTL_CD_02 = sOPPRID;         // 오퍼id

                //#20180607 해피쿠폰 발송시 쿠폰번호 저장안되는 증상 수정 start
                //기존
                //if (m_cEtcItem.HP_ADD_INFO_SCH.Trim() != "" && m_cEtcItem.HP_ADD_INFO_SCH.Length >= 100)
                //변경
                if (m_cEtcItem.HP_ADD_INFO_SCH.Trim() != "")
                //#20180607 해피쿠폰 발송시 쿠폰번호 저장안되는 증상 수정 end
                {
                    m_cEtcItem.OCCUR_ENTRY_11 = CmUtil.MidH(m_cEtcItem.HP_ADD_INFO_SCH,17,11);// m_cEtcItem.HP_ADD_INFO_SCH.Substring(16, 11);
                    /*
                    int nNowPos = 0;
                    string[] aIrtRsp = new string[Column.POINT_ADD_INFO_SEARCH.LEN.Length];
                    ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SEARCH.LEN, Column.POINT_ADD_INFO_SEARCH.TYPE, Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SCH), ref nNowPos, ref aIrtRsp);

                    // 앱고객 여부(N:일반, Y:앱고객)
                    m_cEtcItem.OCCUR_ENTRY_12 = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointHPAPPYN];
                    // 고객명 설정
                    string sCustInfo = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointMEMINFO];
                    if (sCustInfo != "" && CmUtil.IntParse(sCustInfo.Substring(0, 1)) > 0)
                    {
                        //m_cEtcItem.HP_CUST_NAME = CmUtil.MidH(sCustInfo, 17, 20).Trim();    // 고객명
                        m_cEtcItem.OCCUR_ENTRY_10 = CmUtil.MidH(sCustInfo, 45, 10).Trim();  // 회원번호
                    }
                    */
                }

                // 해피포인트 아이템 설정
                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                m_cEtcItem.SEQ = alEtcItem.Count + 1;
                alEtcItem.Add(m_cEtcItem);

            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region CancelPayment 결제 취소
        /// <summary>
        /// 결제 취소
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CancelPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;

            try
            {
                
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region CompletePayment 결제 확정
        /// <summary>
        /// 결제 확정
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CompletePayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region RefundPayment 결제 반품
        /// <summary>
        /// 결제 반품
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string RefundPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
 
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region SetMenualPayment
        public string SetMenualPayment(string[] aParam)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region 해피포인트 조회 실행
        /// <summary>
        /// 해피포인트 조회 실행
        /// </summary>
        public string ExecutePointHappyPointIrt(string sTradeDiv, string sTrType, string sPointType, string sInPutType, string sInPutData, string sInEncData, string sReqDivCd, string sOPPRID)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return UserCom.RST_OK;

                string sAddInfo = "";
                sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID                               
                sAddInfo += CmUtil.RPadH(sReqDivCd, 2);                     // 요청구분코드 - 13:단골고객쿠폰발급요청, 14:단골고객쿠폰발급요청취소
                sAddInfo += CmUtil.RPadH(sOPPRID, 188);                     // VReserved - 오퍼id (16)

                string sVanCD = GetPayDtlCdToVanCode(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);    // 승인업체 코드 조회
                if (sVanCD == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                    return sRet;
                }

                // 포인트 조회
                string[] aIrtRsp = null;

                // 마지막 파라미터 sHpAppAfterSaveYN를 전문의 기타업무 여부로 사용한다. "1" 인 경우 기타업무
                sRet = ExecutePointIrt(sTradeDiv, m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, sVanCD, sTrType, sPointType, sInPutType, sInPutData, sInEncData, 0, "", "", "", "", "", "", sAddInfo, ref aIrtRsp, "", "", "1");
                if (sRet != UserCom.RST_OK)
                {
                    WinManager.ErrorMessage(sRet);
                    return sRet;
                }

                if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                {
                    m_cEtcItem.ETC_DTL_CD_05 = PosConst.PAY_DC_TYPE.NORMAL;                                         // 할인결제구분 (1:결제, 2:할인)

                    m_cEtcItem.OCCUR_ENTRY_01 = sInPutData.Length > 16 ? sInPutData.Substring(0, 16) : sInPutData;  // 카드번호
                    m_cEtcItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResApprNo].Trim();                 // 승인번호
                    m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 0, 6);     // 승인일자
                    m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 6, 4);     // 승인시간
                    m_cEtcItem.OCCUR_ENTRY_05 = sInPutType;             // 입력 구분
                    //m_cEtcItem.OCCUR_ENTRY_06 = sApprNo;                // 원승인번호
                    //m_cEtcItem.OCCUR_ENTRY_07 = sApprDate;              // 원승인일자
                    m_cEtcItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;   //승인구분
                    m_cEtcItem.OCCUR_ENTRY_09 = "0";                    // 거래후 적립 구분(0:일반, 1:사후)
                    m_cEtcItem.OCCUR_ENTRY_16 = sVanCD;                 // VAN 구분
                    m_cEtcItem.OCCUR_ENTRY_18 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResStoreNo];                       // 가맹점번호
                    m_cEtcItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 결제수단명
                    m_cEtcItem.OCCUR_ENTRY_21 = GetPayDtlCdToCashBillYn(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 현금영수증 발행여부

                    m_cEtcItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                    //m_cEtcItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;      // 빌분리 번호
                    //m_cEtcItem.CanFiller1 = sInEncData;
                    //m_cEtcItem.HP_RESERVED = aIrtRsp[Column.POS_RES_POINT.SEQ.ResReserved].Trim();      // 예약필드
                    //m_cEtcItem.HP_CAMPAIGN_INFO = aIrtRsp[Column.POS_RES_POINT.SEQ.ResCampaign].Trim(); // 캠페인정보
                    
                    m_cEtcItem.HP_ADD_INFO_SCH = aIrtRsp[Column.POS_RES_POINT.SEQ.ResAddRespon].Trim();     // 추가응답정보
                }
                else
                {
                    m_cEtcItem.OCCUR_ENTRY_01 = sInPutData.Length > 16 ? sInPutData.Substring(0, 16) : sInPutData;  // 카드번호
                    m_cEtcItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResApprNo].Trim();                 // 승인번호
                    m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 0, 6);     // 승인일자
                    m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 6, 4);     // 승인시간
                    m_cEtcItem.OCCUR_ENTRY_05 = sInPutType;             // 입력 구분
                    //m_cEtcItem.OCCUR_ENTRY_06 = sApprNo;                // 원승인번호
                    //m_cEtcItem.OCCUR_ENTRY_07 = sApprDate;              // 원승인일자

                    m_cEtcItem.HP_ADD_INFO_SAVE = aIrtRsp[Column.POS_RES_POINT.SEQ.ResAddRespon].Trim();    // 추가응답정보
                }


                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

    }
}
